// Author: Vladimir Savic
// E-mail: vladimirsvc@yahoo.com

#include "StateAbstract.h"
#include "StateMachineAbstract.h"
#include "DataTypes.h"

//    <-                        NUMBER_OF_TM_COLUMNS                              ->
//    <-            3 bytes          -><-       external commands 4 bytes         ->
//    ------------------------------------------------------------------------------
//    |    DT    |     PS   |    TPS   |   Cmd1   |   Cmd2   |   Cmd3   |   Cmd4   |
//    ------------------------------------------------------------------------------
// S1 |<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|
//    ------------------------------------------------------------------------------
// S2 |<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|
//    ------------------------------------------------------------------------------
// S3 |<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|
//    ------------------------------------------------------------------------------
// S4 |<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|<- BYTE ->|
//    ------------------------------------------------------------------------------

#define NUMBER_OF_STATES   4
#define NUMBER_OF_EXT_CMD  4
#define NUMBER_OF_TM_COLUMNS ( NUMBER_OF_EXT_CMD + 3 )

       void Initialization                 ( void* ptrSma );
static void StateInitialization            ( void )        ;
       void TransitionMatrixInitialization ( void* tm )    ;
       void StartProcessing                ( void )        ;
       void SetCommand                     ( void* cmd )   ;
       void ProcessCommand                 ( void )        ;
static void DoTransition                   ( void* state ) ;